com.jnape.palatable.lambda.monoid.builtin

## Class LeftAny<L,R>

- java.lang.Object
- - com.jnape.palatable.lambda.monoid.builtin.LeftAny<L,R>

- Type Parameters:
    `L` - The left parameter type
    `R` - The right parameter type
  All Implemented Interfaces:
    Fn1<Monoid<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>>, Fn2<Monoid<L>,Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>, Fn3<Monoid<L>,Either<L,R>,Either<L,R>,Either<L,R>>, MonoidFactory<Monoid<L>,Either<L,R>>, SemigroupFactory<Monoid<L>,Either<L,R>>, Applicative<Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<Monoid<L>,?>>, Cartesian<Monoid<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<?,?>>, Cocartesian<Monoid<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<?,?>>, Contravariant<Monoid<L>,Profunctor<?,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<?,?>>>, Functor<Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<Monoid<L>,?>>, Profunctor<Monoid<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<?,?>>, Monad<Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<Monoid<L>,?>>, MonadReader<Monoid<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<Monoid<L>,?>>, MonadRec<Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<Monoid<L>,?>>, MonadWriter<Monoid<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<Monoid<L>,?>>

      public final class LeftAny<L,R>
      extends Object
      implements MonoidFactory<Monoid<L>,Either<L,R>>

  A `Monoid` instance formed by ``Either`<L,R>` and a monoid over `L`. The application to two `Either` values is left-biased, such that for a given `Either` `x` and `y`:
  - if both `x` and `y` are left values, the result is the application of the x and y values in terms of the provided monoid, wrapped in `Either.left(L)`
  - if only `x` is a left value, the result is `x`
  - if only `y` is a left value, the result is `y`
  - if neither `x` nor `y` are left values, the result is `y`

  For the `Semigroup`, see `LeftAny`.

  See Also:
    `Monoid`, `Either`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Monoid<Either<L,R>>` | `checkedApply(Monoid<L> lMonoid)` Invoke this function with the given argument, potentially throwing any `Throwable`.
    `static <L,R> LeftAny<L,R>` | `leftAny()`
    `static <L,R> Monoid<Either<L,R>>` | `leftAny(Monoid<L> lMonoid)`
    `static <L,R> Fn1<Either<L,R>,Either<L,R>>` | `leftAny(Monoid<L> lMonoid, Either<L,R> x)`
    `static <L,R> Either<L,R>` | `leftAny(Monoid<L> lMonoid, Either<L,R> x, Either<L,R> y)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.specialized.MonoidFactory

      `apply, apply`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.specialized.SemigroupFactory

      `checkedApply`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `apply, checkedApply, compose, contraMap, diMapL, discardR, flip, fn3, fn3, fn3, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public Monoid<Either<L,R>> checkedApply(Monoid<L> lMonoid)

      Description copied from interface: `Fn2`
      Invoke this function with the given argument, potentially throwing any `Throwable`.
      Specified by:
        `checkedApply` in interface `Fn1<Monoid<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>>`
      Specified by:
        `checkedApply` in interface `Fn2<Monoid<L>,Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>`
      Specified by:
        `checkedApply` in interface `MonoidFactory<Monoid<L>,Either<L,R>>`
      Specified by:
        `checkedApply` in interface `SemigroupFactory<Monoid<L>,Either<L,R>>`
      Parameters:
        `lMonoid` - the argument
      Returns:
        the result of the function application

    - #### leftAny

          public static <L,R> LeftAny<L,R> leftAny()

    - #### leftAny

          public static <L,R> Monoid<Either<L,R>> leftAny(Monoid<L> lMonoid)

    - #### leftAny

          public static <L,R> Fn1<Either<L,R>,Either<L,R>> leftAny(Monoid<L> lMonoid,
                                                                   Either<L,R> x)

    - #### leftAny

          public static <L,R> Either<L,R> leftAny(Monoid<L> lMonoid,
                                                  Either<L,R> x,
                                                  Either<L,R> y)